import * as React from 'react';
import { Params, DropFirst } from 'helperTypes';
declare type ContextReference<TState> = {
    setState: React.Dispatch<React.SetStateAction<TState>>;
    useContext: <T>(context: React.Context<T>) => T;
};
declare type Action<TState, TArgs extends any[] = any, TReturn = any> = (contextReference: ContextReference<TState>, ...args: TArgs) => TReturn;
declare type Actions<TState> = {
    [key: string]: Action<TState>;
};
declare type MappedAction<TState, TAction extends Action<TState>> = (...args: DropFirst<Params<TAction>>) => ReturnType<TAction>;
declare type MappedActions<TState, TActions extends Actions<TState>> = {
    [P in keyof TActions]: MappedAction<TState, TActions[P]>;
};
declare type Store<TState, TActions extends Actions<TState>> = TActions extends undefined ? TState : TState & MappedActions<TState, TActions>;
export default function createStateContext<TState, TActions extends Actions<TState> = {}>(initialState: TState, actions?: TActions): [React.Context<Store<TState, TActions>>, React.FC];
export {};
